Subject: [dnsext] RFC 4408 question

From: Alex Nicoll <[email-masked]>
Date: Thu, 27 Oct 2011 11:18:41 -0400

Folks -

I was trying to ensure my parser for SPF records was up to snuff, when I realized that it doesn't parse tabs as white space, and some folks are using tabs as white spaces.  I wasn't sure if that was part of the spec or not, so I went back to RFC 4408 and checked.  The RFC specifies (section 7) that e-mail header information should use folding white space as per RFC2822, but it does not specify that for TXT/SPF records.  All other references in the document only refer to "spaces".

So - Is there a n RFC out there that specifies what a valid "white-space" character is for SPF?  Should I just use RFC 2822's FWS?  Is there an IETF document which explains that "white space" === "Ascii 0x09, 0x20, ....."?

Thanks in advance for putting up with my noob-ish-ness!

-Alex

Alex Nicoll
Senior Cybersecurity Analyst
CERT
Carnegie Mellon University/Software Engineering Institute
[email-masked]<mailto:[email-masked]>
(412)268-9205 (USA)

"Due to the current economic crisis, the Academic Advisory Council has modified the current exchange rate of pictures to words.  As of October 1st, 2011, a picture is now worth only 396 words.  Please adjust your software accordingly."

---

From: Paul Hoffman <[email-masked]>
Date: Thu, 27 Oct 2011 08:26:03 -0700

I strongly suspect you want to be sending this to the DKIM WG mailing list, not the DNSEXT WG mailing list. DNS doesn't care about this.

--Paul Hoffman

---

From: Alex Nicoll <[email-masked]>
Date: Thu, 27 Oct 2011 11:39:48 -0400

Paul - 

I apologize if the post is off topic, though after your note I checked out the DKIM list.  I honestly don't think they'd care either, as they're more concerned with making sure DKIM gets off the ground than fixing a slightly competing standard.  I couldn't find a ietf-spf list, and yet again I cannot reach openspf.org for some odd reason.  Do you know of another, more relevant place to post?  DNSOP?

-Alex 

-----Original Message-----
From: Paul Hoffman [mailto:[email-masked]] 
Sent: Thursday, October 27, 2011 11:26 AM
To: Alex Nicoll
Cc: [email-masked]
Subject: Re: [dnsext] RFC 4408 question

--Paul Hoffman

---

From: David Conrad <[email-masked]>
Date: Thu, 27 Oct 2011 08:57:24 -0700

Hmm.  I suspect whether the DNS cares about the syntax of RDATA depends on what you consider the DNS.

However, to answer Alex's question, in this particular case I suspect the "be liberal in what you accept" recommendation would be applicable: since tab is generally considered to be in the set of "white space" and its use is unlikely to break anything, I would imagine accepting it would be the most interoperable choice.

Regards,
-drc

On Oct 27, 2011, at 8:26 AM, Paul Hoffman wrote:

> _______________________________________________
> dnsext mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dnsext

---

From: Paul Hoffman <[email-masked]>
Date: Thu, 27 Oct 2011 08:59:27 -0700

On Oct 27, 2011, at 8:39 AM, Alex Nicoll wrote:

> I apologize if the post is off topic, though after your note I checked out the DKIM list.  I honestly don't think they'd care either, as they're more concerned with making sure DKIM gets off the ground than fixing a slightly competing standard.

However, most of the SPF folks are still active on, or at least following, the DKIM work.

>  I couldn't find a ietf-spf list, and yet again I cannot reach openspf.org for some odd reason.  Do you know of another, more relevant place to post?  DNSOP?

Hopefully DNSOP also doesn't care about the internals of such an RRtype. Try the DKIM folks and, if you get silence, you can always ask the authors of RFC 4408.

--Paul Hoffman

---

From: Olafur Gudmundsson <[email-masked]>
Date: Thu, 27 Oct 2011 12:54:00 -0400

On 10/27/2011 11:18 AM, Alex Nicoll wrote:
> Folks –
>
> I was trying to ensure my parser for SPF records was up to snuff, when I
> realized that it doesn’t parse tabs as white space, and some folks are
> using tabs as white spaces. I wasn’t sure if that was part of the spec
> or not, so I went back to RFC 4408 and checked. The RFC specifies
> (section 7) that e-mail header information should use folding white
> space as per RFC2822, but it does not specify that for TXT/SPF records.
> All other references in the document only refer to “spaces”.

This is an real interesting question in particular if we consider it in 
the wider context of what is a "white space" in a Text-like DNS record.

>
> So – Is there a n RFC out there that specifies what a valid
> “white-space” character is for SPF? Should I just use RFC 2822’s FWS? Is
> there an IETF document which explains that “white space” === “Ascii
> 0x09, 0x20, …..”?

I do not think that FWS is the right definition in the DNS context,
as I worry what will happen to various implementation if someone
wants to use CR/LF as a separator in SPF or TXT record :-)

As David Conrad says implementations should be able to deal with both as 
separators thus, feel free to file an errata on RFC4408 clarifying that 
"space" and "tab" are both valid separators, and nothing else.

> Thanks in advance for putting up with my noob-ish-ness!

Again an excellent question that was too oblivious for anyone to have 
the guts to ask.

> Alex Nicoll

	Olafur

---

From: "John Levine" <[email-masked]>
Date: 27 Oct 2011 22:11:14 -0000

> I strongly suspect you want to be sending this to the DKIM WG
> mailing list, not the DNSEXT WG mailing list.  DNS doesn't care
> about this.

I wouldn't do that, unless you want snarky responses pointing out that
DKIM is not SPF.

Both of the authors of RFC 4408 are still around.  Is there some reason
not to write to them and ask?

I don't ever recall seeing a tab in an SPF record, but I also can't
think of any reason not to treat tabs the same as spaces.

R's,
John

---

From: SM <[email-masked]>
Date: Thu, 27 Oct 2011 19:45:59 -0700

Hi Alex,
At 08:39 27-10-2011, Alex Nicoll wrote:
>I apologize if the post is off topic, though after your note I 
>checked out the DKIM list.  I honestly don't think they'd care 
>either, as they're more concerned with making

I don't think that it would be relevant as it has nothing to do with DKIM.

>  sure DKIM gets off the ground than fixing a slightly competing 
> standard.  I couldn't find a ietf-spf list, and yet again I cannot 
> reach openspf.org for some odd reason.  Do you know of another, 
> more relevant place to post?  DNSOP?

It's more of a RFC 4408 question.  DNSOP might not consider it as on topic.

The question seems to be about the term evaluation which uses ANBF 
(RFC 4234 in this case).  As it is about ABNF, you can try 
apps-discuss.  There are also a few people on the list that may help 
with RFC 4408 questions.

Regards,
-sm

---

From: SM <[email-masked]>
Date: Thu, 27 Oct 2011 23:52:36 -0700

Hi Olafur,
>wants to use CR/LF as a separator in SPF or TXT record :-)

On a tangent, CVE-2002-0906 and CVE-2008-2469 might be a of interest 
as a security consideration for some specifications using DNS TXT records.

Regards,
-sm